PRO create_sample_plots_4_webpage_2
	!p.font=-3
	dir='./data/'
	date ='2005-9-26'

	jval = read_saphir_data(date,'JNO2_SR')

	ohdoas = f_assemble_saphir_dataset2(date,'HCHO_DOAS', MPARAM='OH_DOAS', /STDEV, /INTERVAL )

	gc = read_saphir_data(date, 'PERKIN_ELMER' )

	status = f_assemble_saphir_dataset(date,['INTOUCH_FLUX_PRESS_VALVES_ROOF','ASS_METEO'] $
		 , MTIME=60, /WINDOW_AVERAGE, LINEAR_WITH_LIMIT=1)

;	pi = {name: 'Theo Brauers', email:'th.brauers@fz-juelich.de', WORKGROUP:'DOAS' $
;		, INSTITUTE: 'ICG-II', ORGANISATION: 'FZJ', PHONE: '+49-2461-616646'}
;	dataset ={ title: 'SAPHIR status data', data_category: '' , experiment: 'OH measurements', campaign: 'HCHO chemistry' $
;		, type_of_data: 'EXPERIMENT', status_of_file: 'final', source_file: 'f_assemble_saphir_dataset.pro', data_origin:'SAPHIR data base'}
;	platform = { type: 'Chamber', name:'SAPHIR' }
;	global = CREATE_STRUCT('PI', pi, 'DATASET', dataset, 'PLATFORM', platform)
;	status = delete_tag(status, '!GLOBAL')
;	status =  CREATE_STRUCT('!GLOBAL', global, status)
;	write_edf, dir+date+'.saphir.status.edf', status, /INTERVAL

	xr = string2js(date)+3600.*[9.05,13.9]
	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset1.ps' $
		, jval, ohdoas, gc $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, YERR = [0,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, XERR=[0,1,1], S_HAT=0, S_THICK=2 $
		, PSYM=[-204, -205, 206] $
		, SYMSIZE=[.3, .5, .5] $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''


	xr = string2js(date)+3600.*[9.2,9.8]
	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset2.ps' $
		, jval, ohdoas, gc $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, XERR=[1,1,1], S_HAT=0, S_THICK=2 $
		, YERR = [0,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, PSYM=[-204, -205, 206] $
		, SYMSIZE=[.3, .5, .5]*2 $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''

	gcr = icgs_time_slice(gc, string2js(date)+3600.*[9.05,13.9])

	n1 = icgs_timeseries_sync(gcr, jval, /WINDOW_AVERAGE, /STDEV)
	n1 = icgs_timeseries_sync(n1, ohdoas, /WINDOW_AVERAGE, /STDEV)
	r  = icgs_calc(n1, 'RATIO_OH_J == JNO2/DOAS_OH', /TAG)

	n2 = icgs_timeseries_sync(ohdoas, gcr, /STDEV, /LINEAR_WITH)
	n2 = icgs_timeseries_sync(n2, jval, /WINDOW_AVERAGE, /STDEV)

	xr = string2js(date)+3600.*[9.05,13.9]

	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset3.ps' $
		, n1 $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, YERR = [1,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, XERR=[1,1,1], S_HAT=0, S_THICK=2 $
		, PSYM=[-204, -205, 206] $
		, SYMSIZE=2*[.3, .5, .5] $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''

	n2 = icgs_timeseries_sync(gcr, jval, /WINDOW_AVERAGE, /STDEV, /INTERNAL)
	n2 = icgs_timeseries_sync(n2, ohdoas, /WINDOW_AVERAGE, /STDEV, /INTERNAL)

	xr = string2js(date)+3600.*[9.05,13.9]
	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset4.ps' $
		, n2 $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, YERR = [1,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, XERR=[1,1,1], S_HAT=0, S_THICK=2 $
		, PSYM=[-204, -205, 206] $
		, SYMSIZE=2*[.3, .5, .5] $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''


 	r = icgs_correlate(n1, 'JNO2', 'DOAS_OH', /TAG, /MPLOT $
		, PSFLAG=1, PSFILE=dir+date+'.example-dataset3c.ps' $
		, CHARSIZE=.9, CHARTHICK=2. $
		, YERR = 1, XERR = 1, S_HAT=0, S_THICK=5 $
		, PSYM=204, COLOR=1 $
		, YRANGE=[-0.499,4.999] $
		, XRANGE=[-0.499,4.999] $
		, SYMSIZE=1, FIT_EXY=1 $
		, FACTOR= 1e-6, XFACTOR = 1000. $
		, XTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n]' $
		, YTITLE= 'OH [10!u6 !ncm!u-3!n]' $
		, TITLE='', XTHICK=2, YTHICK=2, THICK=2 $
 		)
 	r = icgs_correlate(n2, 'JNO2', 'DOAS_OH', /TAG, /MPLOT $
		, PSFLAG=1, PSFILE=dir+date+'.example-dataset4c.ps' $
		, CHARSIZE=.9, CHARTHICK=2. $
		, YERR = 1, XERR = 1, S_HAT=0, S_THICK=2 $
		, PSYM=204, COLOR=1 $
		, YRANGE=[-0.499,4.999] $
		, XRANGE=[-0.499,4.999] $
		, SYMSIZE=1, FIT_EXY=1 $
		, FACTOR= 1e-6, XFACTOR = 1000. $
		, XTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n]' $
		, YTITLE= 'OH [10!u6 !ncm!u-3!n]' $
		, TITLE='' $
 		)

	n3 = icgs_timeseries_sync(ohdoas, gcr, /LINEAR_WITH)
	n3 = icgs_timeseries_sync(n3, jval, /WINDOW_AVERAGE, /LINEAR_WITH)

	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset5.ps' $
		, n3 $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, YERR = [1,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, XERR=[1,1,1], S_HAT=0, S_THICK=2 $
		, PSYM=[-204, -205, 106] $
		, SYMSIZE=2*[.3, .5, .5] $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''

	n4 = icgs_timeseries_sync(ohdoas, gcr, /SPLINE_INTERPOLATION)
	n4 = icgs_timeseries_sync(n4, jval, /WINDOW_AVERAGE, /LINEAR_WITH)

	mplotw, PSFLAG=1, PSFILE=dir+date+'.example-dataset6.ps' $
		, n4 $
		, CHARSIZE=.75, CHARTHICK=2. $
		, YNAME= ['JNO2', 'DOAS_OH', 'ISOPRENE'], /TAG $
		, XRANGE=xr, XST=1 $
		, YERR = [1,1,1], YRANGE=[-1.999,8.9999], YST=1 $
		, XERR=[1,1,1], S_HAT=0, S_THICK=2 $
		, PSYM=[-204, -205, 106] $
		, SYMSIZE=2*[.3, .5, .5] $
		, FACTOR=[1000, 1e-6, 1.] $
		, L_KEY=2, SHARE_Y=1 $
		, /HLINE, HL_THICK=2 $
		, YTITLE= 'J(NO!d2!n) [10!u-3 !ns!u-1!n] / OH [10!u6 !ncm!u-3!n] / isoprene [ppb]' $
		, TITLE=''




	STOP
END

