;
; this edfcorrelator program is executed by the web server to check the
;
FORWARD_FUNCTION _edf_utils_delete_message

FUNCTION _edf_correlator_html_success, cstrct, PATH=path, ERROR=err
	file = cstrct.correlator_files.master
    zipfile = file+'.correlator.zip' & htmlfile = file+'.correlator.html'
    corrfile = file+'.correlator.txt'
	FILE_DELETE, path+[zipfile, htmlfile, corrfile], /ALLOW_NONEXISTENT, /QUIET



	table = struct2htmltable(cstrct, /BORDER, /SUB, /UPDATE, /FIXED, MAX=10)
	files = FILE_BASENAME(path, FILE_SEARCH(file+'.*', COUNT = c))
	IF c EQ 0 THEN RETURN, 'no files'

	now = string2js(js2string(/NOW))
	hinfo = ''
	h1  = html_header(TITLE='Successfully correlated 2 columns of an edf files! Results for '+file, NO_HR=1)
	h2z = ['<ul>','<li>'+create_href(FILE_BASENAME(zipfile))+'</li>','</ul>']
	h2f = '<li>'+create_href(files)+'</li>'
	h2f = ['<ul>',h2f,'</ul>']
	h2  = ['<table cellspacing="2" cellpadding="1" border="0" width ="700"><tr><td><hr>' $
		, '<p>The file <strong>'+FILE_BASENAME(file)+'</strong> was successfully correlated.' $
		, table $
		, 'Please select from the list of input/output files:</p>', h2f $
		, '<p>You can also download all files at</p>',h2z $
		, '<p>If you have problems reading the output files please go back to the ' $
		+ create_href('http://saphir.fz-juelich.de/eurochamp/','Eurochamp page at SAPHIR') $
	 	+ ' for further info.</p>' $
	 	, _edf_utils_delete_message() $
	 	, '<hr></td></tr></table>']
	h3 = html_trailer(_EXTRA=e, NO_HR=1)
	html=[h1, h2, h3]
	_edf_utils_put_file, htmlfile, html
	files = [files, FILE_BASENAME(htmlfile)]
	IF !version.os_family EQ 'unix' THEN $
        FOR i = 0, N_ELEMENTS(files)-1 DO SPAWN, 'zip -9 -j '+zipfile+' '+path+files[i]
RETURN, 'html & zip file created ....'
END



FUNCTION _edf_correlator_struct_test, mstrct
	sections = TAG_NAMES(mstrct)
	IF N_ELEMENTS(sections) NE 3 THEN RETURN, 903
	IF sections[0] NE 'CORRELATOR_PARAMS' THEN RETURN, 905
	sec0 = TAG_NAMES(mstrct.(0))
	sec0taglist = ['XNAME', 'YNAME' $
		, 'WALD_ORIGIN', 'FIT_EXY', 'POLYFIT']
	IF N_ELEMENTS(a_and_b(sec0,sec0taglist)) NE N_ELEMENTS(sec0taglist) THEN RETURN, 917
	IF sections[1] NE 'CORRELATOR_FILES' THEN RETURN, 907
	sec1 = TAG_NAMES(mstrct.(1))
	IF sec1[0] NE 'MASTER' THEN RETURN, 909
	IF sections[2] NE 'CORRELATOR_PLOT' THEN RETURN, 913
	sec2 = TAG_NAMES(mstrct.(2))
	sec2taglist = ['SYMSIZE', 'COLOR', 'PSYM' $
		, 'XFACTOR', 'XRANGE', 'XERR' $
		, 'YFACTOR', 'YRANGE', 'YERR' $
		, 'XTITLE' , 'YTITLE', 'TITLE' $
		, 'CC_NAME' ]
	IF N_ELEMENTS(a_and_b(sec2,sec2taglist)) NE N_ELEMENTS(sec2taglist) THEN RETURN, 927
	RETURN, 0
END

FUNCTION _edf_correlator_correlate, cstrct, PATH=path
	xname    = STRTRIM(cstrct.correlator_params.xname)
	yname    = STRTRIM(cstrct.correlator_params.yname)
	wald_ori = FIX(cstrct.correlator_params.wald_origin) NE 0
	fit_exy  = FIX(cstrct.correlator_params.fit_exy) NE 0
	polyfit  = FIX(cstrct.correlator_params.polyfit) NE 0

	xrange   = FLOAT(STRSPLIT(/EXTR, cstrct.correlator_plot.xrange,' '))
	yrange   = FLOAT(STRSPLIT(/EXTR, cstrct.correlator_plot.yrange,' '))
	xfactor  = FLOAT(cstrct.correlator_plot.xfactor) LE 0. ? 1. : FLOAT(cstrct.correlator_plot.xfactor)
	yfactor  = FLOAT(cstrct.correlator_plot.yfactor) LE 0. ? 1. : FLOAT(cstrct.correlator_plot.yfactor)
	symsize  = FLOAT(cstrct.correlator_plot.symsize) LE 0. ? 1. : FLOAT(cstrct.correlator_plot.symsize)
	psym     = FIX(cstrct.correlator_plot.psym) LE 0 ? 1 : FIX(cstrct.correlator_plot.psym)<255
	color    = FIX(cstrct.correlator_plot.color) LE 0 ? 1 : FIX(cstrct.correlator_plot.color)<8
	xerr     = FIX(cstrct.correlator_plot.xerr) NE 0
	yerr     = FIX(cstrct.correlator_plot.yerr) NE 0
	title    = STRTRIM(STRCOMPRESS(cstrct.correlator_plot.title),2)
	xtitle   = STRTRIM(STRCOMPRESS(cstrct.correlator_plot.xtitle),2)
	ytitle   = STRTRIM(STRCOMPRESS(cstrct.correlator_plot.ytitle),2)
	IF STRLEN(title) GT 0 THEN title2 = title
	IF STRLEN(xtitle) GT 0 THEN xtitle2 = xtitle
	IF STRLEN(ytitle) GT 0 THEN ytitle2 = ytitle


	r = icgs_correlate(*cstrct.correlator_structs.master, xname, yname $
		, /MPLOT $
		, PSFILE=path+cstrct.correlator_files.master+'.correlator.ps', PSFLAG=1 $
		, PSYM= psym $
		, COLOR=color $
		, XRANGE=xrange, YRANGE=yrange $
		, SYMSIZE = symsize $
		, XFACTOR = xfactor $
		, FACTOR = yfactor $
		, CHARTHICK=1.7, CHARSIZE=.70 $
		, YERR=yerr, XERR=xerr, S_HAT=0 $
		, XTITLE=xtitle2, YTITLE =ytitle2, TITLE=title2 $
		, FIT_EXY=fit_exy $
		, WALD_ORIGIN=wald_ori $
		, POLYFIT=1 $
		)

	cstrct = CREATE_STRUCT(cstrct, 'CORRELATOR_RESULTS', r)
	RETURN, 0
END


FUNCTION edf_correlator_2, file, _EXTRA=e

	_edf_utils_def_color_sysv2

	path = FILE_DIRNAME(file, /MARK_DIRECTORY)
	name = FILE_BASENAME(file)

; logfile for messages to operator, not for user
	logfile = path + js2string(/NOW, FORM='Y-M-D')+'.edf-correlator.log'
	info = edf_correlator_date(VERSION=v, TIME=t, COPYRIGHT=c)
	logtext = ['!! edf_correlator --- version: '+ v + ' created '+t $
		, '!! edf_correlator --- copyright: '+ c , '!! ']

IF icg_ini_file(FILE=file, STRUCT=cstrct, /READER, _EXTRA=e) THEN RETURN, 903
	r = _edf_correlator_struct_test(cstrct) & IF r THEN RETURN, r

; read data files into structures
	b = CREATE_STRUCT('MASTER', PTR_NEW(read_edf(path+cstrct.correlator_files.master, ERROR=err)))
	IF err NE 0 THEN RETURN, 909

; concat the data with the ini file structure
	cstrct = CREATE_STRUCT(cstrct, 'CORRELATOR_STRUCTS', b)

; do the correlation
	IF _edf_correlator_correlate(cstrct, PATH=path) THEN BEGIN
		status = 99
	ENDIF ELSE BEGIN
		stat = 0
		r3 = _edf_correlator_html_success(cstrct, PATH=path, ERROR=err)
		icg_message, r3, FILE=logfile, /_TIME
	ENDELSE

; kill the heap variables
	HEAP_FREE, cstrct
	RETURN, stat
END

PRO edf_correlator
;
; file incl path is given thru the command line arguments
; return code 91 on error
; edf_checker_2 returns error codes 92, 93
;
edf_utils
IF LMGR(/RUNTIME) THEN BEGIN
	file = COMMAND_LINE_ARGS(COUNT= c)
	IF c NE 1 THEN BEGIN
		info = edf_correlator_date(VERSION=v, TIME=t, COPYRIGHT=c)
		PRINT, 'edf_correlator '+v+' created '+t
		EXIT, STATUS = 91
	ENDIF
	stat = edf_correlator_2(file, DELETE=delete)
	EXIT, STATUS = stat
ENDIF ELSE BEGIN
	file = (FILE_SEARCH('./data/', '*.edf_correlator.ini', COUNT =c))[0]
	file = (FILE_SEARCH('./data/', 'b*.ini', COUNT =c))[0]
	IF c EQ 0 THEN STOP
	stat = edf_correlator_2(file) & PRINT, stat
 	RETURN
ENDELSE
END