;
; this edfmerger program is executed by the web server to check the
; *.edf files sent to be sent to the icg-ii eurochamp server
;
;
FORWARD_FUNCTION _edf_utils_delete_message

FUNCTION _edf_merger_html_success, file, ERROR=err


    zipfile = file+'.merger.zip' & htmlfile = file+'.merger.html'
    path = FILE_DIRNAME(file, /MARK)
	FILE_DELETE, zipfile, htmlfile, /ALLOW_NONEXISTENT, /QUIET
	files = FILE_BASENAME(FILE_SEARCH(file+'.*', COUNT = c))
	IF c EQ 0 THEN RETURN, 'no files'
	now = string2js(js2string(/NOW))
	hinfo=''
	h1=html_header(TITLE='Successfully merged some edf files! Results for '+file, NO_HR=1)
	h2z = ['<ul>','<li>'+create_href(FILE_BASENAME(zipfile))+'</li>','</ul>']
	h2 = ['<table cellspacing="2" cellpadding="1" border="0" width ="700"><tr><td><hr>' $
		, '<p>The file <strong>'+FILE_BASENAME(file)+'</strong> was successfully merged with the' $
		, 'client files. You can download all files at</p>',h2z $
		, '<p>If you have problems reading the output file please go back to the ' $
		+ create_href('http://saphir.fz-juelich.de/eurochamp/','Eurochamp page at SAPHIR') $
	 	+ ' for further info.</p>' $
	 	, _edf_utils_delete_message() $
	 	, '<hr></td></tr></table>']
	h3=html_trailer(_EXTRA=e, NO_HR=1)
	html=[h1, h2, h3]
	_edf_utils_put_file, htmlfile, html
	files = [files, FILE_BASENAME(htmlfile)]
	IF !version.os_family EQ 'unix' THEN $
        FOR i = 0, N_ELEMENTS(files)-1 DO SPAWN, 'zip -9 -j '+zipfile+' '+path+files[i]
RETURN, 'html & zip file created ....'
END

FUNCTION _edf_merger_struct_test, mstrct
	sections = TAG_NAMES(mstrct)
	IF N_ELEMENTS(sections) NE 2 THEN RETURN, 43
	IF sections[0] NE 'TIME_SYNC_PARAMS' THEN RETURN, 45
	sec0 = TAG_NAMES(mstrct.(0))
	sec0taglist = ['WINDOW_AVERAGE', 'TIME_STEP', 'LINEAR_WITH_LIMIT', 'INTPOL_LIMIT', 'MASTER_WINDOW']
	IF N_ELEMENTS(a_and_b(sec0,sec0taglist)) NE N_ELEMENTS(sec0taglist) THEN RETURN, 47
	IF sections[1] NE 'TIME_SYNC_FILES' THEN RETURN, 49
	sec1 = TAG_NAMES(mstrct.(1))
	IF sec1[0] NE 'MASTER' THEN RETURN, 51
	FOR i=1, N_ELEMENTS(sec1)-1 DO IF sec1[i] NE 'CLIENT'+n2s(i) THEN RETURN, 53
	RETURN, 0
END

FUNCTION _edf_merger_timesync, mstrct, ERRMSG=errmsg
	time_step = DOUBLE(mstrct.time_sync_params.time_step)
	IF time_step LT 1.D OR time_step GT 86400.D THEN time_step=0.D
	window_average = FIX(mstrct.time_sync_params.window_average) NE 0
	intpol_limit = DOUBLE(mstrct.time_sync_params.intpol_limit)
	IF intpol_limit LT 1.D OR intpol_limit GT 86400.D THEN intpol_limit=0.D
	master_window = DOUBLE(mstrct.time_sync_params.master_window)
	IF master_window LT 1.D OR master_window GT 86400.D THEN master_window=0.D
	linear_with_limit = FIX(mstrct.time_sync_params.linear_with_limit) NE 0
	taxis = (*mstrct.time_sync_structs.master).time.param
	trange = [MIN(taxis)-time_step/2., MAX(taxis)+time_step/2.]
	IF time_step GT 0. THEN BEGIN
		nsteps = LONG((trange[1]-trange[0])/time_step)+1
		taxis = trange[0] + LINDGEN(nsteps)*time_step
	ENDIF
	sec1 = TAG_NAMES(mstrct.time_sync_structs)
	master = (*mstrct.time_sync_structs.master)
	IF window_average AND time_step GT 0 THEN BEGIN
		icg = icgs_time_average(master, TIME_STEP=time_step)
		icg = icgs_time_slice(icg, trange)
		yns = (get_tag_and_short_names(/NO_TIME, icg)).tag_name
		mplotw,  /INIT $
			, PSFLAG=1, PSFILE=mstrct._path+mstrct.time_sync_files.master+'.averaged_master_file.ps' $
			, NROW=3, NCOL=3, CHARSIZE= .7, CHARTICK=1.2, PPOS=ppos
		FOR i=0, N_ELEMENTS(yns)-1 DO mplotw, /DONT_CLOSE, /MPLOT $
			, master, icg, YNAME=yns[i], /TAG , /SHARE_Y $
			, COLOR=[1, 2], PSYM=[-1,206], SYMSIZE=[.2,.4] $
			, YNOZERO= 1, YERR=[0,1], XERR=[0,1], S_HAT=0, S_THICK=2$
			, POS=ppos[*,i MOD 9], YTITLE=['DEFAULT',''], NO_LEG=1 $
			, HLINE = 1
		mplotw,  /CLOSE
		write_edf, mstrct._path+mstrct.time_sync_files.master+'.averaged_master_file.edf', icg, /STDEV, /INTERVAL
	ENDIF ELSE icg = (*mstrct.time_sync_structs.master)

	IF STRPOS(icg.time.flag, 'INTERVAL_T') LT 0 THEN BEGIN
		errmsg='interval_t must be present for averaging '
		RETURN, 1
	ENDIF
	IF N_ELEMENTS(sec1) GT 1 THEN BEGIN
		FOR i=1, N_ELEMENTS(sec1)-1 DO BEGIN
			icg = icgs_timeseries_sync(icg, (*mstrct.time_sync_structs.(i)) $
				, WINDOW_AVERAGE=window_average $
			    , VALID = 1 $
			    , LINEAR_WITH_LIMIT = linear_with_limit $
		    	, INTERPOL_LIMIT = interpol_limit $
			    , STDEV=stdev $
				, INTERNAL_ERROR = internal_error $
    			, VERBOSE = 0, FILL_VALUE = fill_value )
		ENDFOR
		write_edf, mstrct._path+mstrct.time_sync_files.master+'.timesync_file.edf', icg, /STDEV, /INTERVAL
		yns = (get_tag_and_short_names(/NO_TIME, icg)).tag_name
		mplotw,  /INIT $
			, PSFLAG=1, PSFILE=mstrct._path+mstrct.time_sync_files.master+'.timesync_file.ps' $
			, NROW=3, NCOL=3, CHARSIZE= .7, CHARTICK=1.2, PPOS=ppos
		FOR i=0, N_ELEMENTS(yns)-1 DO mplotw, /DONT_CLOSE, /MPLOT $
			, icg, YNAME=yns[i], /TAG , /SHARE_Y $
			, COLOR=[1, 2], PSYM=[-1,206], SYMSIZE=[.2,.4] $
			, YNOZERO= 1, YERR=[1], XERR=[1], S_HAT=0, S_THICK=2$
			, POS=ppos[*,i MOD 9], YTITLE=['DEFAULT',''], NO_LEG=1 $
			, HLINE = 1
		mplotw,  /CLOSE
	ENDIF
	RETURN, 0
END

FUNCTION edf_merger_2, file, _EXTRA=e

	_edf_utils_def_color_sysv2
; some startup parameters
	path  = FILE_DIRNAME(file, /MARK)

; logfile for messages to operator, not for user
	logfile = path + js2string(/NOW, FORM='Y-M-D')+'.edf-merger.log'
	info = edf_merger_date(VERSION=v, TIME=t, COPYRIGHT=c)
	logtext = ['!! edf_merger --- version: '+ v + ' created '+t $
	, '!! edf_merger --- copyright: '+ c , '!! ']
	icg_message, logtext, FILE=logfile, /_TIME

; read inifile and analyze
	IF icg_ini_file(FILE=file, STRUCT=mstrct, /READER, _EXTRA=e) THEN RETURN, 93
	r =_edf_merger_struct_test(mstrct) & IF r THEN RETURN, r

; read data files into structures
	b = CREATE_STRUCT('MASTER', PTR_NEW(read_edf(path+mstrct.time_sync_files.master, ERROR=err)))
	IF err NE 0 THEN RETURN, 95
	file_tags = TAG_NAMES(mstrct.time_sync_files)
	FOR i = 1, N_TAGS(mstrct.time_sync_files)-1 DO BEGIN
		b = CREATE_STRUCT(b, file_tags[i], PTR_NEW(read_edf(path+mstrct.time_sync_files.(i),ERROR=err)))
		IF err NE 0 THEN RETURN, 97
	ENDFOR
; concat the data with the ini file structure
	mstrct = CREATE_STRUCT(mstrct, 'TIME_SYNC_STRUCTS', b)
	mstrct = CREATE_STRUCT(mstrct, '_PATH', path)
	html_file_struct, file+'.setup.html', mstrct, /BORDER, /SUB, /UPDATE, /FIXED, MAX=10

; go to the next level
	IF _edf_merger_timesync(mstrct) THEN BEGIN
		status = 99
	ENDIF ELSE BEGIN
		stat = 0
		r3 = _edf_merger_html_success(path+mstrct.time_sync_files.master, ERROR=err)
		icg_message, r3, FILE=logfile, /_TIME
	ENDELSE

; kill the heap variables
	HEAP_FREE, mstrct
	RETURN, stat

END

PRO edf_merger
;
; file incl path is given thru the command line arguments
; return code 91 on error
; edf_checker_2 returns error codes 93
;
edf_utils
IF LMGR(/RUNTIME) THEN BEGIN
	file = COMMAND_LINE_ARGS(COUNT= c)
	IF c NE 1 THEN BEGIN
		info = edf_merger_date(VERSION=v, TIME=t, COPYRIGHT=c)
		PRINT, 'edf_merger '+v+' created '+t
		EXIT, STATUS = 91
	ENDIF
	stat = edf_merger_2(file)
	EXIT, STATUS = stat
ENDIF ELSE BEGIN
	file = (FILE_SEARCH('./data/', '*saphir.edf_merger.ini', COUNT =c))[0]
	IF c EQ 0 THEN STOP
	stat = edf_merger_2(file) & PRINT, stat
	RETURN
ENDELSE
END